#    Juicer: Twisted Little Elves
#    Copyright (C) 2007 Jeffrey Armstrong
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>

import socket

SERVER_PORT = 23479

err_message = 'None'

def read_line(skt, existing=''):
    try:
        text = existing
        while text.find('\n') < 0:
            data = skt.recv(512)
            text = text + data
        return text.split('\n',1)
    except KeyboardInterrupt:
        return 'Nothing returned'

def get_error():
    return err_message

def connect(server,name):
    ret = socket.socket(socket.AF_INET,socket.SOCK_STREAM)
    
    existing = ''
    try:

        ret.connect((server,SERVER_PORT))

        #init_message = ret.recv(512)
        #if init_message.lower() == 'welcome':
        
        ret.send("NAME: %(name)s\n\r" % {'name':name})
        init_message, existing = read_line(ret,existing)
        err_message = init_message
        if init_message.strip().lower() != 'ok':
            ret.close()
            ret = None
    except:
        err_message = "Exception thrown..."
        return None

    return ret

def send_score(server,name,score):
    if server == None:
        return "No connection..."
    
    try:
        server.send("NAME: %(name)s SCORE: %(score).1f\n\r" % {'name':name, 'score':score})
        message, remains = read_line(server)

        if message.strip().lower() != 'ok':
            return "Send failed"
        else:
            return "Score sent"
        
    except:
        return "Connection failed"
    