#    Juicer: Twisted Little Elves
#    Copyright (C) 2007 Jeffrey Armstrong
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>

PLAY_WIDTH = 520
PLAY_HEIGHT = 600

# A single game cell width
CELL_X = 36
CELL_Y = 36

# Grid counts
GRID_X_CNT = 12
GRID_Y_CNT = 10

# Gameplay dimensions
PRESS_WIDTH = GRID_X_CNT*CELL_X
PRESS_HEIGHT = GRID_Y_CNT*CELL_Y

PRESS_X_OFFSET = (PLAY_WIDTH-PRESS_WIDTH)/2
PRESS_Y_OFFSET = 50

# Background image
BKGD_IMG = "playscreen.png"

# Press image
PRESS_IMG = 'press.png'

TITLE = "Juicer"

# Movement speed
XSPEED =  2
YSPEED =  2

# Press movement increment
PMOVE = 2

# Time to move the presses
PMOVE_COUNT = 1000

# Player anim frames
PLAYER_FRAMES = ['fly1.png','fly2.png','fly3.png','fly4.png']

# Game speed (fps)
FPS = 40

# Fruit directory
FRUIT_DIR = 'fruitix'

# Falling fruit speed
FALL_SPEED = 1

# TROUBLE_THRESHHOLD
TROUBLE = 1

# Juice multiplier
JUICE_X = CELL_Y/4

# Time to generate waves again
WAVE_COUNT = 50

# Time to increment juice if necessary
JUICE_INC_COUNT = 300

# Juice wave height
JUICE_SINE_HEIGHT = 10

# Fonts
FONT_NAME = "CAB.TTF"

# Elf animations listing
ELF_ANIM_FILE = "elf.txt"

# Elf image position (top right)
ELF_POSITION = (PLAY_WIDTH-PRESS_X_OFFSET, 20)

# Intro String
INTRO = """
          /  /    /  /  /---  /---  /---/   Juicer: 
         /  /    /  /  /     /     /   /    Twisted Little Elves
        /  /    /  /  /     /---  /-|-/
   /   /  /    /  /  /     /     /  |       PrintStar's Entry for  
  /---/  /----/  /  /---  /---  /   |       PyWeek September 2007
  
  Copyright 2007 Jeffrey Armstrong (aka PrintStar)
  
  Type 'help' to see the options or 'play' to start a local,
  single-player game
  """
  
# About
ABOUT = """
Juicer: Twisted Little Elves is a game of temporary
survival.  The elves love their fruit juices and have
built a nice juicer in a tree stump.  While happily
sitting on a tasty orange, you (a fruitfly) suddenly
find yourself with just moments left to live.  Try
and delay the inevitable as long as possible by 
stalling the juicer with strategically-placed fruit.
"""

# Controls
CONTROLS = """
Start the game simply by typing 'play' at the commmand
prompt.  You will control the tiny fruitfly who is
destined to drown in a Juicer slowly being twisted
lower by a mindless, giggling elf.  Left click to move
the fly around and do nothing.  Right click a fruit to
fly over to the fruit and pick it up.  Fly to the
desired location and use right click to drop the fruit.
In fact, all flying can be achieved using right click,
so left click is somewhat useless.

To quit before the end, simply close the game window.
Pressing any key will also exit the game when you have
finally died.
"""

# Default server
DEF_SERVER = "juicer.rainbow-100.com"