#    Juicer: Twisted Little Elves
#    Copyright (C) 2007 Jeffrey Armstrong
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>

from constants import *
import pygame
from pygame import *

from utility import *

class ElfSprite(pygame.sprite.Sprite):
    def __init__(self, playerid=0):
        pygame.sprite.Sprite.__init__(self)
        self.images = []
        self.current_image = -1
        
        self.id = playerid
        
        fp = data.load(ELF_ANIM_FILE)
        for line in fp.readlines():
            self.images.append(load_image(line.strip()))
        self.next_image()
        
        this_position = (ELF_POSITION[0] + playerid*PLAY_WIDTH, ELF_POSITION[1])
        self.rect = Rect(this_position,(self.image.get_width(), self.image.get_height()))
        self.rect.topright = this_position
        
        self.anim = False
        
        self.nomore = False
        
        self.last_time = False
    
    def get_id(self):
        return self.id
    
    def next_image(self):
        self.current_image = self.current_image + 1
        if self.current_image >= len(self.images):
            self.current_image = 0
        self.image = self.images[self.current_image]

    def run_anim(self):
        self.anim = True
    
    def done(self):
        self.nomore = True
    
    def update(self):
        if (self.anim or self.current_image > 0) and not self.nomore:
            if not self.last_time:
                self.anim = False
                self.next_image()
                self.last_time = True
            else:
                self.last_time = False
            