#    Juicer: Twisted Little Elves
#    Copyright (C) 2007 Jeffrey Armstrong
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>

from constants import *

import pygame
from pygame import *

from utility import *
from fruit import *
from press import *
from player import *

def game_update(players, presses, fruit, juices):
    
    # First, check that the player is under the press
    # and enforce it
    juice = []
    for player in players:
        
        # Build a juice array while we're here
        juice.append(0)
        
        if player.get_dead():
            continue
        
        prcollide = pygame.sprite.spritecollide(player,presses,False)
        if len(prcollide) > 0:
            player.rect.top = prcollide[0].rect.bottom+1
        
        jccollide = pygame.sprite.spritecollide(player,juices,False)
        if len(jccollide) > 0:
            player.rect.bottom = jccollide[0].rect.top
        
        if len(jccollide) + len(prcollide) >= 2:
            player.set_dead(True)
            prcollide[0].stop()
        
    
    # Second, see if any fruit is currently supporting
    # the press.
    for press in presses:
        press.check_for_support(fruit)
        for x in press.get_trouble(fruit):
            x.set_troubled()
        for x in press.get_popped(fruit):
            juice[press.get_id()] = juice[press.get_id()] + x.get_juice()
            x.kill()
    return juice
        