#    Juicer: Twisted Little Elves
#    Copyright (C) 2007 Jeffrey Armstrong
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>

from constants import *
import pygame
from pygame import *

import math

from utility import *

SINE_INC = 5
STEP_INC = 2

JUICE_COLOR = 'purple'

class JuiceSprite(pygame.sprite.Sprite):
    def __init__(self, playerid=0):
        pygame.sprite.Sprite.__init__(self)
        
        self.id = playerid
        self.tgt = 0
        self.value = 0
        self.sine_count = 0
        self.do_waves = False
        self.do_inc = True
        self.rect = Rect(0,0,PRESS_WIDTH,self.value)
        self.gen_image()
        
    def get_id(self):
        return self.id
        
    def gen_image(self):
        self.rect = Rect(0,0,PRESS_WIDTH,self.value)
        self.rect.bottomleft = (PRESS_X_OFFSET+ self.id*PLAY_WIDTH,bottom())
        
        if self.rect.height > 0:
            self.image = Surface((self.rect.width,self.rect.height))
            self.image.convert()
            
            self.image.fill(Color('white'))
            self.image.set_colorkey(Color('white'))
            self.image.set_alpha(128)
        
            poly_points = [(0,self.rect.height)]
            for i in range(0,self.rect.width):
                ang = 4*360*(i + self.sine_count)/self.rect.width
                newpt = sine(ang,JUICE_SINE_HEIGHT/2)
                poly_points.append((i,min(newpt,self.rect.height)))
            poly_points.append((self.rect.width,self.rect.height))
            pygame.draw.polygon(self.image,Color(JUICE_COLOR),poly_points)
            
        else:
            self.image = self.image = Surface((self.rect.width,0))
        
        y = self.rect.height
        if self.value > 0:
            y = self.value
    
        # draw some wavy waves
            
    def update_sine(self):
        self.sine_count = self.sine_count + SINE_INC
        if self.sine_count > self.rect.width:
            self.sine_count = 0

    def inc_juice(self,value):
        self.tgt = self.tgt + JUICE_X*value
    
    def waves(self):
        self.do_waves = True
    
    def update_level(self):
        self.do_inc = True
    
    def update(self):
        if self.do_waves:
            self.do_waves = False
            self.update_sine()
        
        if self.tgt > self.value and self.do_inc:
            self.value = self.value + STEP_INC
            self.do_inc = False
        
        self.gen_image()