#    Juicer: Twisted Little Elves
#    Copyright (C) 2007 Jeffrey Armstrong
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>

from constants import *
import pygame
from pygame import *

from utility import *

MSG_FONT_SIZE = 64
MSG_START_X = 30


def display_dead(id,time):
    text = ['Squish!']
    text.append('%(#).1f s' % {'#':float(time)/1000.0})
    return MessageSprite(text,id)

def display_win(id):
    text = ['Winner!']
    return MessageSprite(text,id)

class MessageSprite(pygame.sprite.Sprite):
    def __init__(self, message, playerid=0):
        pygame.sprite.Sprite.__init__(self)
        
        self.rect = Rect(playerid*PLAY_WIDTH,0,PLAY_WIDTH,PLAY_HEIGHT)
        self.message = message
    
        self.font = pygame.font.Font(data.filepath(FONT_NAME),MSG_FONT_SIZE)
        self.color = Color('black')
        
        self.gen_image()
    
    def set_message(self,value):
        self.message = value
        self.gen_image()
        
    def gen_image(self):
        self.image = Surface((PLAY_WIDTH,PLAY_HEIGHT))
        self.image.convert()
        self.image.fill(Color('white'))
        self.image.set_colorkey(Color('white'))
        
        if self.message != None:
            starty = len(self.message)*(MSG_FONT_SIZE+5)
            starty = self.rect.height/2 - starty/2
        
            for line in self.message:            
                txt = self.font.render(line,True,self.color)
                self.image.blit(txt,(MSG_START_X, starty))            
                starty = starty + 5 + MSG_FONT_SIZE
                
    def update(self):
        pass