#    Juicer: Twisted Little Elves
#    Copyright (C) 2007 Jeffrey Armstrong
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>

from constants import *

import data
import pygame

import os.path
import random

import math

sine_scales = []

def load_image(name, colorkey=-1):
    if name == 'null':
        return None    
    try:
        image = pygame.image.load(data.filepath(name))
    except pygame.error, message:
        print 'Cannot load image:', data.filepath(name)
        raise SystemExit, message
    
    if colorkey is not None:
        if colorkey is -1:
            colorkey = image.get_at((0,0))
        image.set_colorkey(colorkey, pygame.RLEACCEL)
    image = image.convert()
   
    return image

def togrid(xy, player):
    x = xy[0] - player*PLAY_WIDTH
    y = PLAY_HEIGHT - xy[1]
    
    x = int((x-PRESS_X_OFFSET)/CELL_X)
    y = int((y-PRESS_Y_OFFSET)/CELL_Y)
    return limit(x,0,GRID_X_CNT-1), limit(y,0,GRID_Y_CNT-1)

def toxy(gxy, player):
    x = gxy[0]*CELL_X+CELL_X/2+PRESS_X_OFFSET+player*PLAY_WIDTH
    y = PLAY_HEIGHT-(gxy[1]*CELL_Y+CELL_Y/2+PRESS_Y_OFFSET)
    return x,y

def limit(value, minl, maxl):
    return max(minl,min(value,maxl))

def sign(value):
    a = 0
    if value != 0:
        a = value/abs(value)
    return a

def bottom():
    return PLAY_HEIGHT - PRESS_Y_OFFSET

def random_grid():
    return (random.randrange(0,GRID_X_CNT),random.randrange(0,GRID_Y_CNT))

def sine(value, scale):
    if len(sine_scales) == 0:
        for i in range(0,360):
            sine_scales.append(int(float(scale)*(math.sin(float(i)*math.pi/180.0)+1.0)))
    
    while value >= 360:
        value = value - 360
        
    return sine_scales[value]